Skip to content

Moment.js-based date

This tutorial shows you how to create a custom date cell type using Moment.js and the Pikaday calendar picker, with format auto-correction and per-column configuration.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { getRenderer } from 'handsontable/renderers';
import { editorFactory } from 'handsontable/editors';
import { registerCellType } from 'handsontable/cellTypes';
import moment from 'moment';
import Pikaday from '@handsontable/pikaday';
// Register all Handsontable's modules.
registerAllModules();
/* start:skip-in-preview */
const data = [
{
id: 640329,
itemName: 'Lunar Core',
itemNo: 'XJ-12',
leadEngineer: 'Ellen Ripley',
cost: 350000,
inStock: true,
category: 'Lander',
itemQuality: 87,
origin: '🇺🇸 USA',
quantity: 2,
valueStock: 700000,
repairable: false,
supplierName: 'TechNova',
restockDate: '2025-08-01',
operationalStatus: 'Awaiting Parts',
},
{
id: 863104,
itemName: 'Zero Thrusters',
itemNo: 'QL-54',
leadEngineer: 'Sam Bell',
cost: 450000,
inStock: false,
category: 'Propulsion',
itemQuality: 0,
origin: '🇩🇪 Germany',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'PropelMax',
restockDate: '2025-09-15',
operationalStatus: 'In Maintenance',
},
{
id: 395603,
itemName: 'EVA Suits',
itemNo: 'PM-67',
leadEngineer: 'Alex Rogan',
cost: 150000,
inStock: true,
category: 'Equipment',
itemQuality: 79,
origin: '🇮🇹 Italy',
quantity: 50,
valueStock: 7500000,
repairable: true,
supplierName: 'SuitCraft',
restockDate: '2025-10-05',
operationalStatus: 'Ready for Testing',
},
{
id: 679083,
itemName: 'Solar Panels',
itemNo: 'BW-09',
leadEngineer: 'Dave Bowman',
cost: 75000,
inStock: true,
category: 'Energy',
itemQuality: 95,
origin: '🇺🇸 USA',
quantity: 10,
valueStock: 750000,
repairable: false,
supplierName: 'SolarStream',
restockDate: '2025-11-10',
operationalStatus: 'Operational',
},
{
id: 912663,
itemName: 'Comm Array',
itemNo: 'ZR-56',
leadEngineer: 'Louise Banks',
cost: 125000,
inStock: false,
category: 'Communication',
itemQuality: 0,
origin: '🇯🇵 Japan',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'CommTech',
restockDate: '2025-12-20',
operationalStatus: 'Decommissioned',
},
{
id: 315806,
itemName: 'Habitat Dome',
itemNo: 'UJ-23',
leadEngineer: 'Dr. Ryan Stone',
cost: 1000000,
inStock: true,
category: 'Shelter',
itemQuality: 93,
origin: '🇨🇦 Canada',
quantity: 3,
valueStock: 3000000,
repairable: false,
supplierName: 'DomeInnovate',
restockDate: '2026-01-25',
operationalStatus: 'Operational',
},
];
/* end:skip-in-preview */
// Get the DOM element with the ID 'example1' where the Handsontable will be rendered
const container = document.querySelector('#example1');
const correctFormat = (value, dateFormat) => {
const dateFromDate = moment(value);
const dateFromMoment = moment(value, dateFormat);
const isAlphanumeric = value.search(/[A-Za-z]/g) > -1;
let date;
if (
(dateFromDate.isValid() && dateFromDate.format('x') === dateFromMoment.format('x')) ||
!dateFromMoment.isValid() ||
isAlphanumeric
) {
date = dateFromDate;
} else {
date = dateFromMoment;
}
return date.format(dateFormat);
};
const cellDateTypeDefinition = {
renderer: getRenderer('text'),
validator(value, callback) {
let valid = true;
if (value === null || value === undefined) {
value = '';
}
let isValidFormat = moment(value, this.dateFormat, true).isValid();
let isValidDate = moment(new Date(value)).isValid() || isValidFormat;
if (this.allowEmpty && value === '') {
isValidDate = true;
isValidFormat = true;
}
if (!isValidDate) {
valid = false;
}
if (!isValidDate && isValidFormat) {
valid = true;
}
if (isValidDate && !isValidFormat) {
if (this.correctFormat === true) {
const correctedValue = correctFormat(value, this.dateFormat);
this.instance.setDataAtCell(this.visualRow, this.visualCol, correctedValue, 'dateValidator');
valid = true;
} else {
valid = false;
}
}
callback(valid);
},
editor: editorFactory({
position: 'portal',
shortcuts: [
{
keys: [['ArrowLeft']],
callback: (editor, _event) => {
// @ts-ignore
editor.pikaday.adjustDate('subtract', 1);
_event.preventDefault();
},
},
{
keys: [['ArrowRight']],
callback: (editor, _event) => {
// @ts-ignore
editor.pikaday.adjustDate('add', 1);
_event.preventDefault();
},
},
{
keys: [['ArrowUp']],
callback: (editor, _event) => {
// @ts-ignore
editor.pikaday.adjustDate('subtract', 7);
_event.preventDefault();
},
},
{
keys: [['ArrowDown']],
callback: (editor, _event) => {
// @ts-ignore
editor.pikaday.adjustDate('add', 7);
_event.preventDefault();
},
},
],
init(editor) {
editor.parentDestroyed = false;
// create the input element on init. This is a text input that color picker will be attached to.
editor.input = editor.hot.rootDocument.createElement('input');
editor.datePicker = editor.container;
// Prevent recognizing clicking on datepicker as clicking outside of table.
editor.hot.rootDocument.addEventListener('mousedown', (event) => {
if (event.target && event.target.classList.contains('pika-day')) {
editor.hideDatepicker(editor);
}
});
},
getDatePickerConfig(editor) {
const htInput = editor.input;
const options = {};
if (editor.cellProperties && editor.cellProperties.datePickerConfig) {
Object.assign(options, editor.cellProperties.datePickerConfig);
}
const origOnSelect = options.onSelect;
const origOnClose = options.onClose;
options.field = htInput;
options.trigger = htInput;
options.container = editor.datePicker;
options.bound = false;
options.keyboardInput = false;
options.format = options.format ?? editor.getDateFormat(editor);
options.reposition = options.reposition || false;
// Set the RTL to `false`. Due to the https://github.com/Pikaday/Pikaday/issues/647 bug, the layout direction
// of the date picker is controlled by juggling the "dir" attribute of the root date picker element.
options.isRTL = false;
options.onSelect = function (date) {
let dateStr;
if (!isNaN(date.getTime())) {
dateStr = moment(date).format(editor.getDateFormat(editor));
}
editor.setValue(dateStr);
if (origOnSelect) {
origOnSelect.call(editor.pikaday, date);
}
if (Handsontable.helper.isMobileBrowser()) {
editor.hideDatepicker(editor);
}
};
options.onClose = () => {
if (!editor.parentDestroyed) {
editor.finishEditing(false);
}
if (origOnClose) {
origOnClose();
}
};
return options;
},
hideDatepicker(editor) {
editor.pikaday.hide();
},
showDatepicker(editor, event) {
const dateFormat = editor.getDateFormat(editor);
// TODO: view is not exported in the handsontable library d.ts, so we need to use @ts-ignore
// @ts-ignore
const isMouseDown = editor.hot.view.isMouseDown();
const isMeta = event && 'keyCode' in event ? Handsontable.helper.isFunctionKey(event.keyCode) : false;
let dateStr;
editor.datePicker.style.display = 'block';
editor.pikaday = new Pikaday(editor.getDatePickerConfig(editor));
// TODO: useMoment is not exported in the pikaday library d.ts, so we need to use @ts-ignore
// @ts-ignore
if (typeof editor.pikaday.useMoment === 'function') {
// @ts-ignore
editor.pikaday.useMoment(moment);
}
// TODO: _onInputFocus is not exported in the pikaday library d.ts, so we need to use @ts-ignore
// @ts-ignore
editor.pikaday._onInputFocus = function () {};
if (editor.originalValue) {
dateStr = editor.originalValue;
if (moment(dateStr, dateFormat, true).isValid()) {
editor.pikaday.setMoment(moment(dateStr, dateFormat), true);
}
// workaround for date/time cells - pikaday resets the cell value to 12:00 AM by default, this will overwrite the value.
if (editor.getValue() !== editor.originalValue) {
editor.setValue(editor.originalValue);
}
if (!isMeta && !isMouseDown) {
editor.setValue('');
}
} else if (editor.cellProperties.defaultDate) {
dateStr = editor.cellProperties.defaultDate;
if (moment(dateStr, dateFormat, true).isValid()) {
editor.pikaday.setMoment(moment(dateStr, dateFormat), true);
}
if (!isMeta && !isMouseDown) {
editor.setValue('');
}
} else {
// if a default date is not defined, set a soft-default-date: display the current day and month in the
// datepicker, but don't fill the editor input
editor.pikaday.gotoToday();
}
},
afterClose(editor) {
if (editor.pikaday.destroy) {
editor.pikaday.destroy();
}
},
afterOpen(editor, event) {
const cellRect = editor.TD.getBoundingClientRect();
editor.input.style.width = `${cellRect.width}px`;
editor.input.style.height = `${cellRect.height}px`;
editor.showDatepicker(editor, event);
},
getValue(editor) {
return editor.input.value;
},
setValue(editor, value) {
editor.input.value = value;
},
getDateFormat(editor) {
return editor.cellProperties.dateFormat ?? 'DD/MM/YYYY';
},
}),
};
registerCellType('moment-date', cellDateTypeDefinition);
// Define configuration options for the Handsontable
const hotOptions = {
data,
colHeaders: ['Item Name', 'Category', 'Lead Engineer', 'Restock Date', 'Cost'],
autoRowSize: true,
rowHeaders: true,
height: 'auto',
width: '100%',
autoWrapRow: true,
headerClassName: 'htLeft',
columns: [
{ data: 'itemName', type: 'text', width: 130 },
{ data: 'category', type: 'text', width: 120 },
{ data: 'leadEngineer', type: 'text', width: 150 },
{
data: 'restockDate',
type: 'moment-date',
width: 150,
dateFormat: 'YYYY-MM-DD',
correctFormat: true,
datePickerConfig: {
firstDay: 0,
showWeekNumber: true,
disableDayFn(date) {
return date.getDay() === 0 || date.getDay() === 6;
},
},
},
{
data: 'cost',
type: 'numeric',
width: 120,
className: 'htRight',
numericFormat: {
pattern: '$0,0.00',
culture: 'en-US',
},
},
],
licenseKey: 'non-commercial-and-evaluation',
};
// Initialize the Handsontable instance with the specified configuration options
// eslint-disable-next-line no-unused-vars
const hot = new Handsontable(container, hotOptions);
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { getRenderer } from 'handsontable/renderers';
import { editorFactory } from 'handsontable/editors';
import { registerCellType } from 'handsontable/cellTypes';
import moment from 'moment';
import Pikaday from '@handsontable/pikaday';
// Register all Handsontable's modules.
registerAllModules();
/* start:skip-in-preview */
const data = [
{
id: 640329,
itemName: 'Lunar Core',
itemNo: 'XJ-12',
leadEngineer: 'Ellen Ripley',
cost: 350000,
inStock: true,
category: 'Lander',
itemQuality: 87,
origin: '🇺🇸 USA',
quantity: 2,
valueStock: 700000,
repairable: false,
supplierName: 'TechNova',
restockDate: '2025-08-01',
operationalStatus: 'Awaiting Parts',
},
{
id: 863104,
itemName: 'Zero Thrusters',
itemNo: 'QL-54',
leadEngineer: 'Sam Bell',
cost: 450000,
inStock: false,
category: 'Propulsion',
itemQuality: 0,
origin: '🇩🇪 Germany',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'PropelMax',
restockDate: '2025-09-15',
operationalStatus: 'In Maintenance',
},
{
id: 395603,
itemName: 'EVA Suits',
itemNo: 'PM-67',
leadEngineer: 'Alex Rogan',
cost: 150000,
inStock: true,
category: 'Equipment',
itemQuality: 79,
origin: '🇮🇹 Italy',
quantity: 50,
valueStock: 7500000,
repairable: true,
supplierName: 'SuitCraft',
restockDate: '2025-10-05',
operationalStatus: 'Ready for Testing',
},
{
id: 679083,
itemName: 'Solar Panels',
itemNo: 'BW-09',
leadEngineer: 'Dave Bowman',
cost: 75000,
inStock: true,
category: 'Energy',
itemQuality: 95,
origin: '🇺🇸 USA',
quantity: 10,
valueStock: 750000,
repairable: false,
supplierName: 'SolarStream',
restockDate: '2025-11-10',
operationalStatus: 'Operational',
},
{
id: 912663,
itemName: 'Comm Array',
itemNo: 'ZR-56',
leadEngineer: 'Louise Banks',
cost: 125000,
inStock: false,
category: 'Communication',
itemQuality: 0,
origin: '🇯🇵 Japan',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'CommTech',
restockDate: '2025-12-20',
operationalStatus: 'Decommissioned',
},
{
id: 315806,
itemName: 'Habitat Dome',
itemNo: 'UJ-23',
leadEngineer: 'Dr. Ryan Stone',
cost: 1000000,
inStock: true,
category: 'Shelter',
itemQuality: 93,
origin: '🇨🇦 Canada',
quantity: 3,
valueStock: 3000000,
repairable: false,
supplierName: 'DomeInnovate',
restockDate: '2026-01-25',
operationalStatus: 'Operational',
},
];
/* end:skip-in-preview */
// Get the DOM element with the ID 'example1' where the Handsontable will be rendered
const container = document.querySelector('#example1')!;
const correctFormat = (value: string, dateFormat: string): string => {
const dateFromDate = moment(value);
const dateFromMoment = moment(value, dateFormat);
const isAlphanumeric = value.search(/[A-Za-z]/g) > -1;
let date;
if ((dateFromDate.isValid() && dateFromDate.format('x') === dateFromMoment.format('x')) ||
!dateFromMoment.isValid() ||
isAlphanumeric) {
date = dateFromDate;
} else {
date = dateFromMoment;
}
return date.format(dateFormat);
}
const cellDateTypeDefinition = {
renderer: getRenderer('autocomplete'),
validator: function(value, callback) {
let valid = true;
if (value === null || value === undefined) {
value = '';
}
let isValidFormat = moment(value, this.dateFormat, true).isValid();
let isValidDate = moment(new Date(value)).isValid() || isValidFormat;
if (this.allowEmpty && value === '') {
isValidDate = true;
isValidFormat = true;
}
if (!isValidDate) {
valid = false;
}
if (!isValidDate && isValidFormat) {
valid = true;
}
if (isValidDate && !isValidFormat) {
if (this.correctFormat === true) {
const correctedValue = correctFormat(value, this.dateFormat);
this.instance.setDataAtCell(this.visualRow, this.visualCol, correctedValue, 'dateValidator');
valid = true;
} else {
valid = false;
}
}
callback(valid);
},
editor: editorFactory({
position: 'portal',
shortcuts: [
{
keys: [['ArrowLeft']],
callback: (editor, _event) => {
// @ts-ignore
editor.pikaday.adjustDate('subtract', 1);
_event.preventDefault();
},
},
{
keys: [['ArrowRight']],
callback: (editor, _event) => {
// @ts-ignore
editor.pikaday.adjustDate('add', 1);
_event.preventDefault();
},
},
{
keys: [['ArrowUp']],
callback: (editor, _event) => {
// @ts-ignore
editor.pikaday.adjustDate('subtract', 7);
_event.preventDefault();
},
},
{
keys: [['ArrowDown']],
callback: (editor, _event) => {
// @ts-ignore
editor.pikaday.adjustDate('add', 7);
_event.preventDefault();
},
},
],
init(editor) {
editor.parentDestroyed = false;
// create the input element on init. This is a text input that color picker will be attached to.
editor.input = editor.hot.rootDocument.createElement('input');
editor.datePicker = editor.container;
// Prevent recognizing clicking on datepicker as clicking outside of table.
editor.hot.rootDocument.addEventListener('mousedown', (event) => {
if (event.target && event.target.classList.contains('pika-day')) {
editor.hideDatepicker(editor);
}
});
},
getDatePickerConfig(editor) {
const htInput = editor.input;
const options = {};
if (editor.cellProperties && editor.cellProperties.datePickerConfig) {
Object.assign(options, editor.cellProperties.datePickerConfig);
}
const origOnSelect = options.onSelect;
const origOnClose = options.onClose;
options.field = htInput;
options.trigger = htInput;
options.container = editor.datePicker;
options.bound = false;
options.keyboardInput = false;
options.format = options.format ?? editor.getDateFormat(editor);
options.reposition = options.reposition || false;
// Set the RTL to `false`. Due to the https://github.com/Pikaday/Pikaday/issues/647 bug, the layout direction
// of the date picker is controlled by juggling the "dir" attribute of the root date picker element.
options.isRTL = false;
options.onSelect = function (date) {
let dateStr;
if (!isNaN(date.getTime())) {
dateStr = moment(date).format(editor.getDateFormat(editor));
}
editor.setValue(dateStr);
if (origOnSelect) {
origOnSelect.call(editor.pikaday, date);
}
if (Handsontable.helper.isMobileBrowser()) {
editor.hideDatepicker(editor);
}
};
options.onClose = () => {
if (!editor.parentDestroyed) {
editor.finishEditing(false);
}
if (origOnClose) {
origOnClose();
}
};
return options;
},
hideDatepicker(editor) {
editor.pikaday.hide();
},
showDatepicker(editor, event) {
const dateFormat = editor.getDateFormat(editor);
// TODO: view is not exported in the handsontable library d.ts, so we need to use @ts-ignore
// @ts-ignore
const isMouseDown = editor.hot.view.isMouseDown();
const isMeta = event && 'keyCode' in event ? Handsontable.helper.isFunctionKey(event.keyCode) : false;
let dateStr;
editor.datePicker.style.display = 'block';
editor.pikaday = new Pikaday(editor.getDatePickerConfig(editor));
// TODO: useMoment is not exported in the pikaday library d.ts, so we need to use @ts-ignore
// @ts-ignore
if (typeof editor.pikaday.useMoment === 'function') {
// @ts-ignore
editor.pikaday.useMoment(moment);
}
// TODO: _onInputFocus is not exported in the pikaday library d.ts, so we need to use @ts-ignore
// @ts-ignore
editor.pikaday._onInputFocus = function () {};
if (editor.originalValue) {
dateStr = editor.originalValue;
if (moment(dateStr, dateFormat, true).isValid()) {
editor.pikaday.setMoment(moment(dateStr, dateFormat), true);
}
// workaround for date/time cells - pikaday resets the cell value to 12:00 AM by default, this will overwrite the value.
if (editor.getValue() !== editor.originalValue) {
editor.setValue(editor.originalValue);
}
if (!isMeta && !isMouseDown) {
editor.setValue('');
}
} else if (editor.cellProperties.defaultDate) {
dateStr = editor.cellProperties.defaultDate;
if (moment(dateStr, dateFormat, true).isValid()) {
editor.pikaday.setMoment(moment(dateStr, dateFormat), true);
}
if (!isMeta && !isMouseDown) {
editor.setValue('');
}
} else {
// if a default date is not defined, set a soft-default-date: display the current day and month in the
// datepicker, but don't fill the editor input
editor.pikaday.gotoToday();
}
},
afterClose(editor) {
if (editor.pikaday.destroy) {
editor.pikaday.destroy();
}
},
afterOpen(editor, event) {
const cellRect = editor.TD.getBoundingClientRect();
editor.input.style.width = `${cellRect.width}px`;
editor.input.style.height = `${cellRect.height}px`;
editor.showDatepicker(editor, event);
},
getValue(editor) {
return editor.input.value;
},
setValue(editor, value) {
editor.input.value = value;
},
getDateFormat(editor) {
return editor.cellProperties.dateFormat ?? 'DD/MM/YYYY';
},
}),
};
registerCellType('moment-date', cellDateTypeDefinition);
// Define configuration options for the Handsontable
const hotOptions: Handsontable.GridSettings = {
data,
colHeaders: ['Item Name', 'Category', 'Lead Engineer', 'Restock Date', 'Cost'],
autoRowSize: true,
rowHeaders: true,
height: 'auto',
width: '100%',
autoWrapRow: true,
headerClassName: 'htLeft',
columns: [
{ data: 'itemName', type: 'text', width: 130 },
{ data: 'category', type: 'text', width: 120 },
{ data: 'leadEngineer', type: 'text', width: 150 },
{
data: 'restockDate',
type: 'moment-date',
width: 150,
dateFormat: 'YYYY-MM-DD',
correctFormat: true,
datePickerConfig: {
firstDay: 0,
showWeekNumber: true,
disableDayFn(date: Date) {
return date.getDay() === 0 || date.getDay() === 6;
},
},
},
{
data: 'cost',
type: 'numeric',
width: 120,
className: 'htRight',
numericFormat: {
pattern: '$0,0.00',
culture: 'en-US',
},
},
],
licenseKey: 'non-commercial-and-evaluation',
};
// Initialize the Handsontable instance with the specified configuration options
// eslint-disable-next-line no-unused-vars
const hot = new Handsontable(container, hotOptions);
CSS
.ht_editor_visible > input {
width: 100%;
height: 100%;
box-sizing: border-box !important;
border: none;
border-radius: 0;
outline: none;
margin-top: -1px;
margin-left: -1px;
box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
var(--ht-cell-editor-border-color, #1a42e8),
0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
var(--ht-cell-editor-shadow-color, transparent) !important;
background-color: var(--ht-cell-editor-background-color, #ffffff) !important;
padding: var(--ht-cell-vertical-padding, 4px)
var(--ht-cell-horizontal-padding, 8px) !important;
border: none !important;
font-family: inherit;
font-size: var(--ht-font-size);
line-height: var(--ht-line-height);
}
.ht_editor_visible > input:focus-visible {
border: none !important;
outline: none !important;
}

Overview

This guide shows how to create a custom date cell type using the Moment.js library. Users can format dates using the Moment.js API.

Difficulty: Beginner Time: ~25 minutes Libraries: moment, @handsontable/pikaday

What You’ll Build

A cell that:

  • Displays dates with a dropdown arrow indicator
  • Opens a Pikaday calendar picker when edited
  • Validates and corrects date formats using Moment.js
  • Supports custom dateFormat options per column
  • Disables weekend selection via datePickerConfig

Prerequisites

Terminal window
npm install moment @handsontable/pikaday
  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { getRenderer } from 'handsontable/renderers';
    import { editorFactory } from 'handsontable/editors';
    import { registerCellType } from 'handsontable/cellTypes';
    import moment from 'moment';
    import Pikaday from '@handsontable/pikaday';
    registerAllModules();

    Why this matters:

    • moment handles date parsing, validation, and formatting
    • Pikaday provides the calendar date picker UI
    • editorFactory creates a portal-based editor that overlays the cell
    • registerCellType registers the custom cell type for use in column config
  2. Create the Date Format Helper

    This helper corrects user input to match the expected date format:

    const correctFormat = (value, dateFormat) => {
    const dateFromDate = moment(value);
    const dateFromMoment = moment(value, dateFormat);
    const isAlphanumeric = value.search(/[A-Za-z]/g) > -1;
    let date;
    if ((dateFromDate.isValid() && dateFromDate.format('x') === dateFromMoment.format('x')) ||
    !dateFromMoment.isValid() ||
    isAlphanumeric) {
    date = dateFromDate;
    } else {
    date = dateFromMoment;
    }
    return date.format(dateFormat);
    }

    What’s happening:

    • Tries to parse the value both as a native date and using Moment.js with the given format
    • Picks the best interpretation and reformats it to the target dateFormat
  3. Create the Renderer

    The example reuses the built-in autocomplete renderer, which displays a dropdown arrow icon indicating the cell has a picker:

    renderer: getRenderer('autocomplete')
  4. Create the Validator

    The validator checks whether the entered value is a valid date and optionally auto-corrects the format:

    validator: function(value, callback) {
    let valid = true;
    if (value === null || value === undefined) {
    value = '';
    }
    let isValidFormat = moment(value, this.dateFormat, true).isValid();
    let isValidDate = moment(new Date(value)).isValid() || isValidFormat;
    if (this.allowEmpty && value === '') {
    isValidDate = true;
    isValidFormat = true;
    }
    if (!isValidDate) {
    valid = false;
    }
    if (!isValidDate && isValidFormat) {
    valid = true;
    }
    if (isValidDate && !isValidFormat) {
    if (this.correctFormat === true) {
    const correctedValue = correctFormat(value, this.dateFormat);
    this.instance.setDataAtCell(this.visualRow, this.visualCol, correctedValue, 'dateValidator');
    valid = true;
    } else {
    valid = false;
    }
    }
    callback(valid);
    }

    What’s happening:

    • Validates the date value against the configured dateFormat using Moment.js
    • If correctFormat is enabled, auto-corrects misformatted but valid dates
    • Empty values pass validation when allowEmpty is set
  5. Create the Editor

    The editor uses editorFactory with position: 'portal' to overlay a Pikaday calendar on the cell. Arrow keys navigate days/weeks in the calendar:

    editor: editorFactory({
    position: 'portal',
    shortcuts: [
    {
    keys: [['ArrowLeft']],
    callback: (editor, _event) => {
    editor.pikaday.adjustDate('subtract', 1);
    _event.preventDefault();
    },
    },
    {
    keys: [['ArrowRight']],
    callback: (editor, _event) => {
    editor.pikaday.adjustDate('add', 1);
    _event.preventDefault();
    },
    },
    {
    keys: [['ArrowUp']],
    callback: (editor, _event) => {
    editor.pikaday.adjustDate('subtract', 7);
    _event.preventDefault();
    },
    },
    {
    keys: [['ArrowDown']],
    callback: (editor, _event) => {
    editor.pikaday.adjustDate('add', 7);
    _event.preventDefault();
    },
    },
    ],
    init(editor) {
    editor.parentDestroyed = false;
    editor.input = editor.hot.rootDocument.createElement('input');
    editor.datePicker = editor.container;
    editor.hot.rootDocument.addEventListener('mousedown', (event) => {
    if (event.target && event.target.classList.contains('pika-day')) {
    editor.hideDatepicker(editor);
    }
    });
    },
    afterOpen(editor, event) {
    const cellRect = editor.TD.getBoundingClientRect();
    editor.input.style.width = `${cellRect.width}px`;
    editor.input.style.height = `${cellRect.height}px`;
    editor.showDatepicker(editor, event);
    },
    afterClose(editor) {
    if (editor.pikaday.destroy) {
    editor.pikaday.destroy();
    }
    },
    getValue(editor) {
    return editor.input.value;
    },
    setValue(editor, value) {
    editor.input.value = value;
    },
    getDateFormat(editor) {
    return editor.cellProperties.dateFormat ?? 'DD/MM/YYYY';
    },
    // ... getDatePickerConfig, showDatepicker, hideDatepicker
    // (see the full example above for complete implementation)
    }),

    What’s happening:

    • init creates the input element and binds the Pikaday container
    • afterOpen sizes the input to match the cell dimensions, then opens the date picker
    • afterClose destroys the Pikaday instance to prevent memory leaks
    • Arrow key shortcuts navigate the calendar (left/right = day, up/down = week)
  6. Style the Editor Input

    The editor input needs CSS to match Handsontable’s native editor appearance. Without this, the input shows default browser borders and focus styles:

    .ht_editor_visible > input {
    width: 100%;
    height: 100%;
    box-sizing: border-box !important;
    border: none;
    border-radius: 0;
    outline: none;
    margin-top: -1px;
    margin-left: -1px;
    box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
    var(--ht-cell-editor-border-color, #1a42e8),
    0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
    var(--ht-cell-editor-shadow-color, transparent) !important;
    background-color: var(--ht-cell-editor-background-color, #ffffff) !important;
    padding: var(--ht-cell-vertical-padding, 4px)
    var(--ht-cell-horizontal-padding, 8px) !important;
    border: none !important;
    font-family: inherit;
    font-size: var(--ht-font-size);
    line-height: var(--ht-line-height);
    }
    .ht_editor_visible > input:focus-visible {
    border: none !important;
    outline: none !important;
    }

    Key styling:

    • margin-top: -1px and margin-left: -1px align the editor precisely over the cell border
    • Uses Handsontable’s CSS custom properties (--ht-cell-editor-*) to match the theme
    • inset box-shadow replaces the default border for a consistent editor highlight
    • border: none and outline: none remove default browser focus styles
  7. Register and Use in Handsontable

    registerCellType('moment-date', cellDateTypeDefinition);
    const hotOptions: Handsontable.GridSettings = {
    data,
    colHeaders: ['Item Name', 'Category', 'Lead Engineer', 'Restock Date', 'Cost'],
    autoRowSize: true,
    rowHeaders: true,
    height: 'auto',
    width: '100%',
    autoWrapRow: true,
    headerClassName: 'htLeft',
    columns: [
    { data: 'itemName', type: 'text', width: 130 },
    { data: 'category', type: 'text', width: 120 },
    { data: 'leadEngineer', type: 'text', width: 150 },
    {
    data: 'restockDate',
    type: 'moment-date',
    width: 150,
    dateFormat: 'YYYY-MM-DD',
    correctFormat: true,
    datePickerConfig: {
    firstDay: 0,
    showWeekNumber: true,
    disableDayFn(date) {
    return date.getDay() === 0 || date.getDay() === 6;
    },
    },
    },
    {
    data: 'cost',
    type: 'numeric',
    width: 120,
    className: 'htRight',
    numericFormat: {
    pattern: '$0,0.00',
    culture: 'en-US',
    },
    },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    };
    const hot = new Handsontable(container, hotOptions);

    Key configuration:

    • type: 'moment-date' - uses the custom cell type on the Restock Date column
    • dateFormat: 'YYYY-MM-DD' - the Moment.js format string for parsing and display
    • correctFormat: true - automatically reformats valid dates to the expected format
    • datePickerConfig - passed directly to Pikaday (e.g., disable weekends with disableDayFn)

How It Works - Complete Flow

  1. Initial Render: Cell displays the date value with a dropdown arrow (autocomplete renderer)
  2. User clicks cell: The portal editor opens with an input sized to the cell and a Pikaday calendar below it
  3. Date selection: User picks a date from the calendar or types a value; arrow keys navigate the picker
  4. Validation: Moment.js checks the format and date validity; auto-corrects if correctFormat is enabled
  5. Save: Valid values are saved to the cell; invalid values are rejected

What you learned

You created a custom Moment.js-based date cell type in Handsontable. You used editorFactory with position: 'portal' to overlay a Pikaday calendar, Moment.js for date validation and format auto-correction, and registerCellType to make the cell type reusable across columns.

Next steps

  • Pikaday - A standalone Pikaday date picker recipe that also serves as a migration path from the built-in date cell type.
  • Moment.js time - The same Moment.js pattern applied to time values.
  • Flatpickr - An alternative date picker using the Flatpickr library with dark theme support.

Skip to content

Moment.js-based date

This tutorial shows you how to layer Moment.js on top of Handsontable’s built-in date cell type, so a column keeps its own display format and still accepts loosely written dates.

JavaScript
import { HotTable, HotColumn } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import { registerCellType, DateCellType } from 'handsontable/cellTypes';
import moment from 'moment';
registerAllModules();
// The built-in `date` cell type stores every value in the ISO 8601 format.
const ISO_FORMAT = 'YYYY-MM-DD';
// Converts a loosely written date into ISO.
const toISODate = (value, inputFormat) => {
// The column's own format wins, parsed strictly so a near-miss does not silently shift.
const fromInputFormat = moment(value, inputFormat, true);
if (fromInputFormat.isValid()) {
return fromInputFormat.format(ISO_FORMAT);
}
// Fall back to the browser's parsing for values that format cannot describe, such as
// "March 14, 2025". Handing Moment a Date avoids its string-parsing deprecation warning.
const nativeDate = new Date(value);
return Number.isNaN(nativeDate.getTime()) ? value : moment(nativeDate).format(ISO_FORMAT);
};
const cellDateTypeDefinition = {
// Inherit the built-in date editor (a native date input), its ISO validator, and the source-data
// check that warns when the underlying data is not ISO.
...DateCellType,
// Display the ISO source value in the column's own Moment format. `valueFormatter` runs before the
// renderer, so the inherited renderer receives the formatted string and no custom renderer is needed.
valueFormatter: (value, cellProperties) => {
if (typeof value !== 'string' || value === '') {
return value;
}
const date = moment(value, ISO_FORMAT, true);
return date.isValid() ? date.format(cellProperties.renderFormat ?? ISO_FORMAT) : value;
},
};
// Rewrites a non-ISO value into ISO before it reaches the cell. This runs ahead of both the editor
// and the validator, which is what keeps the built-in ISO-only editor from warning about the raw
// value. It also covers pasted and programmatically written values, which never touch the editor.
function correctDatesBeforeChange(changes) {
changes.forEach((change) => {
if (!change) {
return;
}
const [visualRow, prop, , newValue] = change;
const cellMeta = this.getCellMetaTransient(visualRow, this.propToCol(prop));
if (cellMeta.type !== 'moment-date' ||
cellMeta.correctFormat !== true ||
typeof newValue !== 'string' ||
newValue === '') {
return;
}
if (!moment(newValue, ISO_FORMAT, true).isValid()) {
change[3] = toISODate(newValue, cellMeta.inputFormat ?? ISO_FORMAT);
}
});
}
registerCellType('moment-date', cellDateTypeDefinition);
const data = [
{
id: 640329,
itemName: 'Lunar Core',
itemNo: 'XJ-12',
leadEngineer: 'Ellen Ripley',
cost: 350000,
inStock: true,
category: 'Lander',
itemQuality: 87,
origin: '🇺🇸 USA',
quantity: 2,
valueStock: 700000,
repairable: false,
supplierName: 'TechNova',
restockDate: '2025-08-01',
operationalStatus: 'Awaiting Parts',
},
{
id: 863104,
itemName: 'Zero Thrusters',
itemNo: 'QL-54',
leadEngineer: 'Sam Bell',
cost: 450000,
inStock: false,
category: 'Propulsion',
itemQuality: 0,
origin: '🇩🇪 Germany',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'PropelMax',
restockDate: '2025-09-15',
operationalStatus: 'In Maintenance',
},
{
id: 395603,
itemName: 'EVA Suits',
itemNo: 'PM-67',
leadEngineer: 'Alex Rogan',
cost: 150000,
inStock: true,
category: 'Equipment',
itemQuality: 79,
origin: '🇮🇹 Italy',
quantity: 50,
valueStock: 7500000,
repairable: true,
supplierName: 'SuitCraft',
restockDate: '2025-10-05',
operationalStatus: 'Ready for Testing',
},
{
id: 679083,
itemName: 'Solar Panels',
itemNo: 'BW-09',
leadEngineer: 'Dave Bowman',
cost: 75000,
inStock: true,
category: 'Energy',
itemQuality: 95,
origin: '🇺🇸 USA',
quantity: 10,
valueStock: 750000,
repairable: false,
supplierName: 'SolarStream',
restockDate: '2025-11-10',
operationalStatus: 'Operational',
},
{
id: 912663,
itemName: 'Comm Array',
itemNo: 'ZR-56',
leadEngineer: 'Louise Banks',
cost: 125000,
inStock: false,
category: 'Communication',
itemQuality: 0,
origin: '🇯🇵 Japan',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'CommTech',
restockDate: '2025-12-20',
operationalStatus: 'Decommissioned',
},
{
id: 315806,
itemName: 'Habitat Dome',
itemNo: 'UJ-23',
leadEngineer: 'Dr. Ryan Stone',
cost: 1000000,
inStock: true,
category: 'Shelter',
itemQuality: 93,
origin: '🇨🇦 Canada',
quantity: 3,
valueStock: 3000000,
repairable: false,
supplierName: 'DomeInnovate',
restockDate: '2026-01-25',
operationalStatus: 'Operational',
},
];
/* end:skip-in-preview */
const ExampleComponent = () => {
return (<HotTable data={data} colHeaders={['Item Name', 'Category', 'Lead Engineer', 'Restock Date', 'Cost']} autoRowSize={true} rowHeaders={true} height="auto" width="100%" autoWrapRow={true} headerClassName="htLeft" beforeChange={correctDatesBeforeChange} licenseKey="non-commercial-and-evaluation">
<HotColumn data="itemName" type="text" width={130}/>
<HotColumn data="category" type="text" width={120}/>
<HotColumn data="leadEngineer" type="text" width={150}/>
<HotColumn data="restockDate" type="moment-date" width={150} renderFormat="MMM D, YYYY" inputFormat="MM/DD/YYYY" correctFormat={true}/>
<HotColumn data="cost" type="numeric" width={120} className="htRight" locale="en-US" numericFormat={{ style: 'currency', currency: 'USD', minimumFractionDigits: 2 }}/>
</HotTable>);
};
export default ExampleComponent;
TypeScript
import { HotTable, HotColumn } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import { registerCellType, DateCellType } from 'handsontable/cellTypes';
import { CellChange, CellProperties } from 'handsontable/settings';
import { HotInstance } from 'handsontable';
import moment from 'moment';
registerAllModules();
// The built-in `date` cell type stores every value in the ISO 8601 format.
const ISO_FORMAT = 'YYYY-MM-DD';
// Converts a loosely written date into ISO.
const toISODate = (value: string, inputFormat: string): string => {
// The column's own format wins, parsed strictly so a near-miss does not silently shift.
const fromInputFormat = moment(value, inputFormat, true);
if (fromInputFormat.isValid()) {
return fromInputFormat.format(ISO_FORMAT);
}
// Fall back to the browser's parsing for values that format cannot describe, such as
// "March 14, 2025". Handing Moment a Date avoids its string-parsing deprecation warning.
const nativeDate = new Date(value);
return Number.isNaN(nativeDate.getTime()) ? value : moment(nativeDate).format(ISO_FORMAT);
};
// The custom cell properties this cell type reads, on top of the built-in ones.
type MomentDateCellProperties = CellProperties & {
renderFormat?: string;
inputFormat?: string;
correctFormat?: boolean;
};
const cellDateTypeDefinition = {
// Inherit the built-in date editor (a native date input), its ISO validator, and the source-data
// check that warns when the underlying data is not ISO.
...DateCellType,
// Display the ISO source value in the column's own Moment format. `valueFormatter` runs before the
// renderer, so the inherited renderer receives the formatted string and no custom renderer is needed.
valueFormatter: (value: unknown, cellProperties: MomentDateCellProperties) => {
if (typeof value !== 'string' || value === '') {
return value;
}
const date = moment(value, ISO_FORMAT, true);
return date.isValid() ? date.format(cellProperties.renderFormat ?? ISO_FORMAT) : value;
},
};
// Rewrites a non-ISO value into ISO before it reaches the cell. This runs ahead of both the editor
// and the validator, which is what keeps the built-in ISO-only editor from warning about the raw
// value. It also covers pasted and programmatically written values, which never touch the editor.
function correctDatesBeforeChange(this: HotInstance, changes: (CellChange | null)[]): void {
changes.forEach((change) => {
if (!change) {
return;
}
const [visualRow, prop, , newValue] = change;
const cellMeta = this.getCellMetaTransient(
visualRow,
this.propToCol(prop as string) as number
) as MomentDateCellProperties;
if (
cellMeta.type !== 'moment-date' ||
cellMeta.correctFormat !== true ||
typeof newValue !== 'string' ||
newValue === ''
) {
return;
}
if (!moment(newValue, ISO_FORMAT, true).isValid()) {
change[3] = toISODate(newValue, cellMeta.inputFormat ?? ISO_FORMAT);
}
});
}
registerCellType('moment-date', cellDateTypeDefinition);
/* start:skip-in-preview */
interface InventoryItem {
id: number;
itemName: string;
itemNo: string;
leadEngineer: string;
cost: number;
inStock: boolean;
category: string;
itemQuality: number;
origin: string;
quantity: number;
valueStock: number;
repairable: boolean;
supplierName: string;
restockDate: string;
operationalStatus: string;
}
const data: InventoryItem[] = [
{
id: 640329,
itemName: 'Lunar Core',
itemNo: 'XJ-12',
leadEngineer: 'Ellen Ripley',
cost: 350000,
inStock: true,
category: 'Lander',
itemQuality: 87,
origin: '🇺🇸 USA',
quantity: 2,
valueStock: 700000,
repairable: false,
supplierName: 'TechNova',
restockDate: '2025-08-01',
operationalStatus: 'Awaiting Parts',
},
{
id: 863104,
itemName: 'Zero Thrusters',
itemNo: 'QL-54',
leadEngineer: 'Sam Bell',
cost: 450000,
inStock: false,
category: 'Propulsion',
itemQuality: 0,
origin: '🇩🇪 Germany',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'PropelMax',
restockDate: '2025-09-15',
operationalStatus: 'In Maintenance',
},
{
id: 395603,
itemName: 'EVA Suits',
itemNo: 'PM-67',
leadEngineer: 'Alex Rogan',
cost: 150000,
inStock: true,
category: 'Equipment',
itemQuality: 79,
origin: '🇮🇹 Italy',
quantity: 50,
valueStock: 7500000,
repairable: true,
supplierName: 'SuitCraft',
restockDate: '2025-10-05',
operationalStatus: 'Ready for Testing',
},
{
id: 679083,
itemName: 'Solar Panels',
itemNo: 'BW-09',
leadEngineer: 'Dave Bowman',
cost: 75000,
inStock: true,
category: 'Energy',
itemQuality: 95,
origin: '🇺🇸 USA',
quantity: 10,
valueStock: 750000,
repairable: false,
supplierName: 'SolarStream',
restockDate: '2025-11-10',
operationalStatus: 'Operational',
},
{
id: 912663,
itemName: 'Comm Array',
itemNo: 'ZR-56',
leadEngineer: 'Louise Banks',
cost: 125000,
inStock: false,
category: 'Communication',
itemQuality: 0,
origin: '🇯🇵 Japan',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'CommTech',
restockDate: '2025-12-20',
operationalStatus: 'Decommissioned',
},
{
id: 315806,
itemName: 'Habitat Dome',
itemNo: 'UJ-23',
leadEngineer: 'Dr. Ryan Stone',
cost: 1000000,
inStock: true,
category: 'Shelter',
itemQuality: 93,
origin: '🇨🇦 Canada',
quantity: 3,
valueStock: 3000000,
repairable: false,
supplierName: 'DomeInnovate',
restockDate: '2026-01-25',
operationalStatus: 'Operational',
},
];
/* end:skip-in-preview */
const ExampleComponent = () => {
return (
<HotTable
data={data}
colHeaders={['Item Name', 'Category', 'Lead Engineer', 'Restock Date', 'Cost']}
autoRowSize={true}
rowHeaders={true}
height="auto"
width="100%"
autoWrapRow={true}
headerClassName="htLeft"
beforeChange={correctDatesBeforeChange}
licenseKey="non-commercial-and-evaluation"
>
<HotColumn data="itemName" type="text" width={130} />
<HotColumn data="category" type="text" width={120} />
<HotColumn data="leadEngineer" type="text" width={150} />
<HotColumn
data="restockDate"
type="moment-date"
width={150}
renderFormat="MMM D, YYYY"
inputFormat="MM/DD/YYYY"
correctFormat={true}
/>
<HotColumn
data="cost"
type="numeric"
width={120}
className="htRight"
locale="en-US"
numericFormat={{ style: 'currency', currency: 'USD', minimumFractionDigits: 2 }}
/>
</HotTable>
);
};
export default ExampleComponent;

Overview

This guide shows how to build a custom date cell type on top of the built-in date cell type using the Moment.js library. The built-in type supplies the editor — a native date input — along with ISO validation. Moment.js adds two things it does not do: a per-column display format, and correction of dates written in another format.

Difficulty: Beginner Time: ~15 minutes Libraries: moment

What You’ll Build

A cell that:

  • Stores dates in the ISO 8601 format (YYYY-MM-DD), as the built-in date cell type requires
  • Displays them in a per-column Moment.js format, such as MMM D, YYYY
  • Opens the browser’s native date picker when edited
  • Rewrites pasted dates such as 03/14/2025 into ISO
  • Rejects values that are not dates at all

Prerequisites

Terminal window
npm install moment
  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { registerCellType, DateCellType } from 'handsontable/cellTypes';
    import moment from 'moment';
    registerAllModules();

    Why this matters:

    • DateCellType is the built-in date cell type: a native date input, an ISO validator, and a source-data check
    • moment handles date parsing and formatting
    • registerCellType registers the composed cell type for use in column config
  2. Create the ISO Conversion Helper

    The built-in cell type stores every value as an ISO date string. This helper turns a loosely written date into that format:

    const ISO_FORMAT = 'YYYY-MM-DD';
    const toISODate = (value: string, inputFormat: string): string => {
    const fromInputFormat = moment(value, inputFormat, true);
    if (fromInputFormat.isValid()) {
    return fromInputFormat.format(ISO_FORMAT);
    }
    const nativeDate = new Date(value);
    return Number.isNaN(nativeDate.getTime()) ? value : moment(nativeDate).format(ISO_FORMAT);
    };

    What’s happening:

    • Parses strictly against the column’s inputFormat first, so a near-miss does not silently shift the date
    • Falls back to the browser’s own parsing for values that format cannot describe, such as March 14, 2025
    • Returns the value untouched when neither reading produces a date, so the validator can reject it

    Hand the fallback a Date rather than the raw string. moment('03/14/2025') logs a deprecation warning for any input that is not RFC2822 or ISO; moment(new Date('03/14/2025')) does not.

  3. Format the Display Value

    valueFormatter converts the stored ISO value into the format the column displays:

    valueFormatter: (value, cellProperties) => {
    if (typeof value !== 'string' || value === '') {
    return value;
    }
    const date = moment(value, ISO_FORMAT, true);
    return date.isValid() ? date.format(cellProperties.renderFormat ?? ISO_FORMAT) : value;
    },

    Why valueFormatter and not a renderer?

    Handsontable applies valueFormatter before the renderer and hands the renderer the formatted result. A custom renderer that ran moment() on its value would receive the already-formatted string and parse the wrong thing. Formatting here lets the cell type keep the inherited renderer untouched.

    The editor is unaffected: it reads the raw source data, so the native date input always receives an ISO value no matter how the cell displays it.

  4. Correct Loosely Written Values in beforeChange

    The native date input can only produce ISO values, so anything typed in the editor is already correct. Pasted values and programmatic writes never reach the editor, and that is where a MM/DD/YYYY string arrives. Correct it in beforeChange:

    function correctDatesBeforeChange(changes) {
    changes.forEach((change) => {
    if (!change) {
    return;
    }
    const [visualRow, prop, , newValue] = change;
    const cellMeta = this.getCellMetaTransient(visualRow, this.propToCol(prop));
    if (
    cellMeta.type !== 'moment-date' ||
    cellMeta.correctFormat !== true ||
    typeof newValue !== 'string' ||
    newValue === ''
    ) {
    return;
    }
    if (!moment(newValue, ISO_FORMAT, true).isValid()) {
    change[3] = toISODate(newValue, cellMeta.inputFormat ?? ISO_FORMAT);
    }
    });
    }

    Pass it as the grid’s beforeChange handler.

    Why beforeChange and not the validator?

    beforeChange runs before both the editor and the validator, so the corrected ISO value is the only value the rest of the grid ever sees. Correcting later — inside a validator, with setDataAtCell — also works, but the built-in editor receives the raw value first and logs DateEditor: value must be in ISO date format. Rewriting the change up front avoids that entirely, and it leaves the inherited ISO validator untouched, so a value Moment.js cannot read is still flagged.

    getCellMetaTransient reads the resolved cell configuration without permanently materializing meta for the cell, which is what you want for a per-change read inside a hook.

  5. Compose and Register the Cell Type

    Spread the built-in cell type, then override the two pieces Moment.js owns:

    const cellDateTypeDefinition = {
    ...DateCellType,
    valueFormatter: /* from Step 3 */,
    };
    registerCellType('moment-date', cellDateTypeDefinition);
    const hotOptions: Handsontable.GridSettings = {
    data,
    colHeaders: ['Item Name', 'Category', 'Lead Engineer', 'Restock Date', 'Cost'],
    autoRowSize: true,
    rowHeaders: true,
    height: 'auto',
    width: '100%',
    autoWrapRow: true,
    headerClassName: 'htLeft',
    columns: [
    { data: 'itemName', type: 'text', width: 130 },
    { data: 'category', type: 'text', width: 120 },
    { data: 'leadEngineer', type: 'text', width: 150 },
    {
    data: 'restockDate',
    type: 'moment-date',
    width: 150,
    renderFormat: 'MMM D, YYYY',
    inputFormat: 'MM/DD/YYYY',
    correctFormat: true,
    },
    {
    data: 'cost',
    type: 'numeric',
    width: 120,
    className: 'htRight',
    locale: 'en-US',
    numericFormat: {
    style: 'currency',
    currency: 'USD',
    minimumFractionDigits: 2,
    },
    },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    beforeChange: correctDatesBeforeChange,
    };
    const hot = new Handsontable(container, hotOptions);

    Key configuration:

    • type: 'moment-date' - uses the composed cell type on the Restock Date column
    • renderFormat: 'MMM D, YYYY' - the Moment.js format the cell displays
    • inputFormat: 'MM/DD/YYYY' - the format tried first when correcting a pasted value
    • correctFormat: true - opts the column into that correction

    Spreading DateCellType copies its CELL_TYPE value, 'date', into the object. Handsontable ignores that key when expanding a cell type, so registering the result under a different name is safe.

How It Works - Complete Flow

  1. Initial Render: the cell holds an ISO date; valueFormatter converts it to renderFormat for display
  2. User clicks cell: the built-in editor opens the browser’s native date picker, populated from the raw ISO source value
  3. Date selection: the native input always yields an ISO value, so it is stored as-is
  4. Paste: beforeChange rewrites a pasted non-ISO value to ISO when correctFormat is set
  5. Save: values that are not dates fail the built-in ISO validator and are flagged

What you learned

You built a custom cell type by composing the built-in date cell type with Moment.js. You used valueFormatter for per-column display formatting, corrected loosely written values in beforeChange so the ISO-only editor never sees them, and registered the result with registerCellType.

Next steps

  • Pikaday - A standalone Pikaday date picker recipe that also serves as a migration path from the built-in date cell type.
  • Moment.js time - The same Moment.js pattern applied to time values.
  • Flatpickr - An alternative date picker using the Flatpickr library with dark theme support.

Skip to content

Moment.js-based date

This tutorial shows you how to layer Moment.js on top of Handsontable’s built-in date cell type, so a column keeps its own display format and still accepts loosely written dates.

TypeScript
/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings, HotTableModule } from '@handsontable/angular-wrapper';
import { registerCellType, DateCellType } from 'handsontable/cellTypes';
import { CellChange, CellProperties } from 'handsontable/settings';
import { HotInstance } from 'handsontable';
import moment from 'moment';
// The built-in `date` cell type stores every value in the ISO 8601 format.
const ISO_FORMAT = 'YYYY-MM-DD';
// Converts a loosely written date into ISO.
const toISODate = (value: string, inputFormat: string): string => {
// The column's own format wins, parsed strictly so a near-miss does not silently shift.
const fromInputFormat = moment(value, inputFormat, true);
if (fromInputFormat.isValid()) {
return fromInputFormat.format(ISO_FORMAT);
}
// Fall back to the browser's parsing for values that format cannot describe, such as
// "March 14, 2025". Handing Moment a Date avoids its string-parsing deprecation warning.
const nativeDate = new Date(value);
return Number.isNaN(nativeDate.getTime()) ? value : moment(nativeDate).format(ISO_FORMAT);
};
// The custom cell properties this cell type reads, on top of the built-in ones.
type MomentDateCellProperties = CellProperties & {
renderFormat?: string;
inputFormat?: string;
correctFormat?: boolean;
};
const cellDateTypeDefinition = {
// Inherit the built-in date editor (a native date input), its ISO validator, and the source-data
// check that warns when the underlying data is not ISO.
...DateCellType,
// Display the ISO source value in the column's own Moment format. `valueFormatter` runs before the
// renderer, so the inherited renderer receives the formatted string and no custom renderer is needed.
valueFormatter: (value: unknown, cellProperties: MomentDateCellProperties) => {
if (typeof value !== 'string' || value === '') {
return value;
}
const date = moment(value, ISO_FORMAT, true);
return date.isValid() ? date.format(cellProperties.renderFormat ?? ISO_FORMAT) : value;
},
};
// Rewrites a non-ISO value into ISO before it reaches the cell. This runs ahead of both the editor
// and the validator, which is what keeps the built-in ISO-only editor from warning about the raw
// value. It also covers pasted and programmatically written values, which never touch the editor.
function correctDatesBeforeChange(this: HotInstance, changes: (CellChange | null)[]): void {
changes.forEach((change) => {
if (!change) {
return;
}
const [visualRow, prop, , newValue] = change;
const cellMeta = this.getCellMetaTransient(
visualRow,
this.propToCol(prop as string) as number
) as MomentDateCellProperties;
if (
cellMeta.type !== 'moment-date' ||
cellMeta.correctFormat !== true ||
typeof newValue !== 'string' ||
newValue === ''
) {
return;
}
if (!moment(newValue, ISO_FORMAT, true).isValid()) {
change[3] = toISODate(newValue, cellMeta.inputFormat ?? ISO_FORMAT);
}
});
}
registerCellType('moment-date', cellDateTypeDefinition);
@Component({
standalone: true,
imports: [HotTableModule],
selector: 'example1-moment-date',
template: `<div><hot-table [data]="data" [settings]="gridSettings"></hot-table></div>`,
})
export class AppComponent {
readonly data = [
{
itemName: 'Lunar Core',
category: 'Lander',
leadEngineer: 'Ellen Ripley',
restockDate: '2025-08-01',
cost: 350000,
},
{
itemName: 'Zero Thrusters',
category: 'Propulsion',
leadEngineer: 'Sam Bell',
restockDate: '2025-09-15',
cost: 450000,
},
{
itemName: 'EVA Suits',
category: 'Equipment',
leadEngineer: 'Alex Rogan',
restockDate: '2025-10-05',
cost: 150000,
},
{
itemName: 'Solar Panels',
category: 'Energy',
leadEngineer: 'Dave Bowman',
restockDate: '2025-11-10',
cost: 75000,
},
{
itemName: 'Comm Array',
category: 'Communication',
leadEngineer: 'Louise Banks',
restockDate: '2025-12-20',
cost: 125000,
},
{
itemName: 'Habitat Dome',
category: 'Shelter',
leadEngineer: 'Dr. Ryan Stone',
restockDate: '2026-01-25',
cost: 1000000,
},
];
readonly gridSettings: GridSettings = {
colHeaders: ['Item Name', 'Category', 'Lead Engineer', 'Restock Date', 'Cost'],
autoRowSize: true,
rowHeaders: true,
height: 'auto',
width: '100%',
autoWrapRow: true,
headerClassName: 'htLeft',
beforeChange: correctDatesBeforeChange,
columns: [
{ data: 'itemName', type: 'text', width: 130 },
{ data: 'category', type: 'text', width: 120 },
{ data: 'leadEngineer', type: 'text', width: 150 },
{
data: 'restockDate',
type: 'moment-date',
width: 150,
// Display format, applied by `valueFormatter`. The stored value stays ISO.
renderFormat: 'MMM D, YYYY',
// Format tried first when correcting a pasted value.
inputFormat: 'MM/DD/YYYY',
correctFormat: true,
},
{
data: 'cost',
type: 'numeric',
width: 120,
className: 'htRight',
locale: 'en-US',
numericFormat: {
style: 'currency',
currency: 'USD',
minimumFractionDigits: 2,
},
},
],
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<example1-moment-date></example1-moment-date>
</div>

Overview

This guide shows how to build a custom date cell type on top of the built-in date cell type using the Moment.js library. The built-in type supplies the editor — a native date input — along with ISO validation. Moment.js adds two things it does not do: a per-column display format, and correction of dates written in another format.

Difficulty: Beginner Time: ~15 minutes Libraries: moment

What You’ll Build

A cell that:

  • Stores dates in the ISO 8601 format (YYYY-MM-DD), as the built-in date cell type requires
  • Displays them in a per-column Moment.js format, such as MMM D, YYYY
  • Opens the browser’s native date picker when edited
  • Rewrites pasted dates such as 03/14/2025 into ISO
  • Rejects values that are not dates at all

Prerequisites

Terminal window
npm install moment
  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { registerCellType, DateCellType } from 'handsontable/cellTypes';
    import moment from 'moment';
    registerAllModules();

    Why this matters:

    • DateCellType is the built-in date cell type: a native date input, an ISO validator, and a source-data check
    • moment handles date parsing and formatting
    • registerCellType registers the composed cell type for use in column config
  2. Create the ISO Conversion Helper

    The built-in cell type stores every value as an ISO date string. This helper turns a loosely written date into that format:

    const ISO_FORMAT = 'YYYY-MM-DD';
    const toISODate = (value: string, inputFormat: string): string => {
    const fromInputFormat = moment(value, inputFormat, true);
    if (fromInputFormat.isValid()) {
    return fromInputFormat.format(ISO_FORMAT);
    }
    const nativeDate = new Date(value);
    return Number.isNaN(nativeDate.getTime()) ? value : moment(nativeDate).format(ISO_FORMAT);
    };

    What’s happening:

    • Parses strictly against the column’s inputFormat first, so a near-miss does not silently shift the date
    • Falls back to the browser’s own parsing for values that format cannot describe, such as March 14, 2025
    • Returns the value untouched when neither reading produces a date, so the validator can reject it

    Hand the fallback a Date rather than the raw string. moment('03/14/2025') logs a deprecation warning for any input that is not RFC2822 or ISO; moment(new Date('03/14/2025')) does not.

  3. Format the Display Value

    valueFormatter converts the stored ISO value into the format the column displays:

    valueFormatter: (value, cellProperties) => {
    if (typeof value !== 'string' || value === '') {
    return value;
    }
    const date = moment(value, ISO_FORMAT, true);
    return date.isValid() ? date.format(cellProperties.renderFormat ?? ISO_FORMAT) : value;
    },

    Why valueFormatter and not a renderer?

    Handsontable applies valueFormatter before the renderer and hands the renderer the formatted result. A custom renderer that ran moment() on its value would receive the already-formatted string and parse the wrong thing. Formatting here lets the cell type keep the inherited renderer untouched.

    The editor is unaffected: it reads the raw source data, so the native date input always receives an ISO value no matter how the cell displays it.

  4. Correct Loosely Written Values in beforeChange

    The native date input can only produce ISO values, so anything typed in the editor is already correct. Pasted values and programmatic writes never reach the editor, and that is where a MM/DD/YYYY string arrives. Correct it in beforeChange:

    function correctDatesBeforeChange(changes) {
    changes.forEach((change) => {
    if (!change) {
    return;
    }
    const [visualRow, prop, , newValue] = change;
    const cellMeta = this.getCellMetaTransient(visualRow, this.propToCol(prop));
    if (
    cellMeta.type !== 'moment-date' ||
    cellMeta.correctFormat !== true ||
    typeof newValue !== 'string' ||
    newValue === ''
    ) {
    return;
    }
    if (!moment(newValue, ISO_FORMAT, true).isValid()) {
    change[3] = toISODate(newValue, cellMeta.inputFormat ?? ISO_FORMAT);
    }
    });
    }

    Pass it as the grid’s beforeChange handler.

    Why beforeChange and not the validator?

    beforeChange runs before both the editor and the validator, so the corrected ISO value is the only value the rest of the grid ever sees. Correcting later — inside a validator, with setDataAtCell — also works, but the built-in editor receives the raw value first and logs DateEditor: value must be in ISO date format. Rewriting the change up front avoids that entirely, and it leaves the inherited ISO validator untouched, so a value Moment.js cannot read is still flagged.

    getCellMetaTransient reads the resolved cell configuration without permanently materializing meta for the cell, which is what you want for a per-change read inside a hook.

  5. Compose and Register the Cell Type

    Spread the built-in cell type, then override the two pieces Moment.js owns:

    const cellDateTypeDefinition = {
    ...DateCellType,
    valueFormatter: /* from Step 3 */,
    };
    registerCellType('moment-date', cellDateTypeDefinition);
    const hotOptions: Handsontable.GridSettings = {
    data,
    colHeaders: ['Item Name', 'Category', 'Lead Engineer', 'Restock Date', 'Cost'],
    autoRowSize: true,
    rowHeaders: true,
    height: 'auto',
    width: '100%',
    autoWrapRow: true,
    headerClassName: 'htLeft',
    columns: [
    { data: 'itemName', type: 'text', width: 130 },
    { data: 'category', type: 'text', width: 120 },
    { data: 'leadEngineer', type: 'text', width: 150 },
    {
    data: 'restockDate',
    type: 'moment-date',
    width: 150,
    renderFormat: 'MMM D, YYYY',
    inputFormat: 'MM/DD/YYYY',
    correctFormat: true,
    },
    {
    data: 'cost',
    type: 'numeric',
    width: 120,
    className: 'htRight',
    locale: 'en-US',
    numericFormat: {
    style: 'currency',
    currency: 'USD',
    minimumFractionDigits: 2,
    },
    },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    beforeChange: correctDatesBeforeChange,
    };
    const hot = new Handsontable(container, hotOptions);

    Key configuration:

    • type: 'moment-date' - uses the composed cell type on the Restock Date column
    • renderFormat: 'MMM D, YYYY' - the Moment.js format the cell displays
    • inputFormat: 'MM/DD/YYYY' - the format tried first when correcting a pasted value
    • correctFormat: true - opts the column into that correction

    Spreading DateCellType copies its CELL_TYPE value, 'date', into the object. Handsontable ignores that key when expanding a cell type, so registering the result under a different name is safe.

How It Works - Complete Flow

  1. Initial Render: the cell holds an ISO date; valueFormatter converts it to renderFormat for display
  2. User clicks cell: the built-in editor opens the browser’s native date picker, populated from the raw ISO source value
  3. Date selection: the native input always yields an ISO value, so it is stored as-is
  4. Paste: beforeChange rewrites a pasted non-ISO value to ISO when correctFormat is set
  5. Save: values that are not dates fail the built-in ISO validator and are flagged

What you learned

You built a custom cell type by composing the built-in date cell type with Moment.js. You used valueFormatter for per-column display formatting, corrected loosely written values in beforeChange so the ISO-only editor never sees them, and registered the result with registerCellType.

Next steps

  • Pikaday - A standalone Pikaday date picker recipe that also serves as a migration path from the built-in date cell type.
  • Moment.js time - The same Moment.js pattern applied to time values.
  • Flatpickr - An alternative date picker using the Flatpickr library with dark theme support.